---
title: CSSStyleSheet.insertRule()
slug: Web/API/CSSStyleSheet/insertRule
tags:
  - API
  - CSSOM
  - CSSStyleSheet
  - Method
  - Reference
---
<div>{{APIRef("CSSOM")}}</div>

<p><span class="seoSummary">The <strong><code>CSSStyleSheet.insertRule()</code></strong> method inserts a new <a href="/en-US/docs/Web/API/CSSRule">CSS rule</a> into the <a href="/en-US/docs/Web/API/CSSStyleSheet">current style sheet</a>, with some <a href="#Restrictions">restrictions</a>.</span></p>

<div class="note">
<p><strong>Note:</strong> Although <code>insertRule()</code> is exclusively a method of {{domxref("CSSStyleSheet")}}, it actually inserts the rule into <code>{{domxref("CSSStyleSheet", "", "", "1")}}.cssRules</code> — its internal {{domxref("CSSRuleList")}}.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><var>stylesheet</var>.insertRule(<var>rule</var> [, <var>index</var>])</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>rule</code></dt>
 <dd>
 <p>A {{domxref("DOMString")}} containing the rule to be inserted. What the inserted rule must contain depends on its type:</p>

 <ul>
  <li><strong>For <a href="/en-US/docs/Web/CSS/Syntax#CSS_statements">rule-sets</a></strong>, both a <a href="/en-US/docs/Web/Guide/CSS/Getting_Started/Selectors">selector</a> and a style declaration.</li>
  <li><strong>For <a href="/en-US/docs/Web/CSS/At-rule">at-rules</a></strong>, both an at-identifier and the rule content.</li>
 </ul>
 </dd>
 <dt><code>index</code> {{optional_inline}}</dt>
 <dd>A positive integer less than or equal to <code>stylesheet.cssRules.length</code>, representing the newly inserted rule's position in <code>{{domxref("CSSStyleSheet", "", "", "1")}}.cssRules</code>. The default is <code>0</code>. (In older implementations, this was required. See <a href="#Browser_compatibility">Browser compatibility</a> for details.)</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>The newly inserted rule's index within the stylesheet's rule-list.</p>

<h3 id="Restrictions">Restrictions</h3>

<p>CSS has some intuitive and not-so-intuitive restrictions affecting where rules can be inserted. Violating them will likely raise a {{domxref("DOMException")}}.</p>

<ul>
 <li>If <code>index</code> &gt; <code>{{domxref("CSSRuleList", "", "", "1")}}.length</code>, the method aborts with an <code>IndexSizeError</code>.</li>
 <li>If <code>rule</code> cannot be inserted at <code>index</code> <code>0</code> due to some CSS constraint, the method aborts with a <code>HierarchyRequestError</code>.</li>
 <li>If more than one rule is given in the <code>rule</code> parameter, the method aborts with a <code>SyntaxError</code>.</li>
 <li>If trying to insert an {{cssxref("@import")}} at-rule after a style rule, the method aborts with a <code>HierarchyRequestError</code>.</li>
 <li>If <code>rule</code> is {{cssxref("@namespace")}} and the rule-list has more than just <code>@import</code> at-rules and/or <code>@namespace</code> at-rules, the method aborts with an <code>InvalidStateError</code>.</li>
</ul>

<h2 id="Examples">Examples</h2>

<h3 id="Inserting_a_new_rule">Inserting a new rule</h3>

<p>This snippet pushes a new rule onto the top of my stylesheet.</p>

<pre class="brush: js">myStyle.insertRule('#blanc { color: white }', 0);
</pre>

<h3 id="Function_to_add_a_stylesheet_rule">Function to add a stylesheet rule</h3>

<pre class="brush: js">/**
 * Add a stylesheet rule to the document (it may be better practice
 * to dynamically change classes, so style information can be kept in
 * genuine stylesheets and avoid adding extra elements to the DOM).
 * Note that an array is needed for declarations and rules since ECMAScript does
 * not guarantee a predictable object iteration order, and since CSS is
 * order-dependent.
 * @param {Array} rules Accepts an array of JSON-encoded declarations
 * @example
addStylesheetRules([
  ['h2', // Also accepts a second argument as an array of arrays instead
    ['color', 'red'],
    ['background-color', 'green', true] // 'true' for !important rules
  ],
  ['.myClass',
    ['background-color', 'yellow']
  ]
]);
*/
function addStylesheetRules (rules) {
  var styleEl = document.createElement('style');

  // Append &lt;style&gt; element to &lt;head&gt;
  document.head.appendChild(styleEl);

  // Grab style element's sheet
  var styleSheet = styleEl.sheet;

  for (var i = 0; i &lt; rules.length; i++) {
    var j = 1,
        rule = rules[i],
        selector = rule[0],
        propStr = '';
    // If the second argument of a rule is an array of arrays, correct our variables.
    if (Array.isArray(rule[1][0])) {
      rule = rule[1];
      j = 0;
    }

    for (var pl = rule.length; j &lt; pl; j++) {
      var prop = rule[j];
      propStr += prop[0] + ': ' + prop[1] + (prop[2] ? ' !important' : '') + ';\n';
    }

    // Insert CSS Rule
    styleSheet.insertRule(selector + '{' + propStr + '}', styleSheet.cssRules.length);
  }
}</pre>

<h2 id="Polyfill">Polyfill</h2>

<p>The below polyfill will correct the input of the arguments of <code>insertRule()</code> to standardize them in Internet Explorer 5–8. It supplements <code>insertRule()</code> with a function that separates the selector from the rules before sending the arguments to the default native <code>insertRule()</code>.</p>

<pre class="brush: js">(function(Sheet_proto){
  var originalInsertRule = Sheet_proto.insertRule;

  if (originalInsertRule.length === 2){ // 2 mandatory arguments: (selector, rules)
    Sheet_proto.insertRule = function(selectorAndRule){
      // First, separate the selector from the rule
      a: for (var i=0, Len=selectorAndRule.length, isEscaped=0, newCharCode=0; i !== Len; ++i) {
        newCharCode = selectorAndRule.charCodeAt(i);
        if (!isEscaped &amp;&amp; (newCharCode === 123)) { // 123 = "{".charCodeAt(0)
          // Secondly, find the last closing bracket
          var openBracketPos = i, closeBracketPos = -1;

          for (; i !== Len; ++i) {
            newCharCode = selectorAndRule.charCodeAt(i);
            if (!isEscaped &amp;&amp; (newCharCode === 125)) { // 125 = "}".charCodeAt(0)
              closeBracketPos = i;
            }
            isEscaped ^= newCharCode===92?1:isEscaped; // 92 = "\\".charCodeAt(0)
          }

          if (closeBracketPos === -1) break a; // No closing bracket was found!
            /*else*/ return originalInsertRule.call(
            this, // the sheet to be changed
            selectorAndRule.substring(0, openBracketPos), // The selector
            selectorAndRule.substring(closeBracketPos), // The rule
            arguments[3] // The insert index
          );
        }

        // Works by if the char code is a backslash, then isEscaped
        // gets flipped (XOR-ed by 1), and if it is not a backslash
        // then isEscaped gets XORed by itself, zeroing it
        isEscaped ^= newCharCode===92?1:isEscaped; // 92 = "\\".charCodeAt(0)
      }
      // Else, there is no unescaped bracket
      return originalInsertRule.call(this, selectorAndRule, "", arguments[2]);
    };
  }
})(CSSStyleSheet.prototype);
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('CSSOM', '#dom-cssstylesheet-insertrule', 'CSSStyleSheet.insertRule')}}</td>
   <td>{{Spec2('CSSOM')}}</td>
   <td>No change from {{SpecName('DOM2 Style')}}.</td>
  </tr>
  <tr>
   <td>{{SpecName('DOM2 Style', 'css.html#CSS-CSSStyleSheet-insertRule', 'CSSStyleSheet.insertRule')}}</td>
   <td>{{Spec2('DOM2 Style')}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.CSSStyleSheet.insertRule")}}</p>

<h3 id="Legacy_browser_support">Legacy browser support</h3>

<p>To support Internet Explorer 8 and below, use: <code>addRule(selector, rule [, index]);</code>. Example: <code>addRule('pre', 'font: 14px verdana'); // add rule at end</code></p>

<p>Also note the non-standard <code><a class="external" href="http://www.quirksmode.org/dom/w3c_css.html#change">removeRule()</a></code> and <code><a class="external" href="http://www.quirksmode.org/dom/w3c_css.html#access">.rules</a></code> instead of {{domxref("CSSStyleSheet.deleteRule","deleteRule()")}} and {{domxref("CSSStyleSheet",".cssRules")}}, respectively.</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("CSSStyleSheet.deleteRule")}}</li>
 <li><a class="external" href="http://www-archive.mozilla.org/docs/web-developer/css1technote/css1tojs.html#priority">Cross-Browser CSS-rules ordering (CSS1)</a></li>
 <li><a class="external" href="http://www.quirksmode.org/dom/w3c_css.html">Quirksmode - CSS</a></li>
</ul>
